﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace SoundBottler
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            locker = new object();
            gDev.Enabled = gStart.Enabled = false;
            Application.DoEvents();

            Timer t = new Timer();
            t.Interval = 100;
            t.Tick += t_Tick;
            t.Start();

            trec = new Timer();
            trec.Interval = 200;
            trec.Tick += trec_Tick;
            //trec.Start();
        }

        void t_Tick(object sender, EventArgs e)
        {
            ((Timer)sender).Stop();

            NAudio.CoreAudioApi.MMDeviceEnumerator mde = new NAudio.CoreAudioApi.MMDeviceEnumerator();
            foreach (
                NAudio.CoreAudioApi.MMDevice device
                 in mde.EnumerateAudioEndPoints(
                    NAudio.CoreAudioApi.DataFlow.All,
                    NAudio.CoreAudioApi.DeviceState.All))
            {
                if (device.DataFlow == NAudio.CoreAudioApi.DataFlow.All ||
                    device.DataFlow == NAudio.CoreAudioApi.DataFlow.Render)
                {
                    gDev.Items.Add(device);
                }
            }
            try
            {
                gDev.SelectedIndex = Convert.ToInt32(File.ReadAllText("SoundBottler.ini"));
            }
            catch
            {
                gDev.SelectedIndex = 0;
            }

            gTime.Font = new System.Drawing.Font(gTime.Font.FontFamily, gTime.Font.Size * 5);
            gDev.Enabled = gStart.Enabled = true;
            ticker = -1;
        }

        private void gDev_SelectedIndexChanged(object sender, EventArgs e)
        {
            File.WriteAllText("SoundBottler.ini", gDev.SelectedIndex.ToString());
        }

        Timer trec;
        int ticker;
        object locker;
        NAudio.Wave.IWaveIn wdt_waveIn;
        NAudio.Wave.WaveFileWriter wdt_writer;

        private void gStart_Click(object sender, EventArgs e)
        {
            lock (locker)
            {
                if (ticker >= 0)
                {
                    wdt_waveIn.StopRecording();
                    wdt_writer.Close();
                    wdt_waveIn.Dispose();
                    wdt_writer.Dispose();
                    gDev.Enabled = true;
                    gStart.Text = "S T A R T";
                    ticker = -1;
                    return;
                }
            }

            ticker = 0;
            gDev.Enabled = false;
            string fn = DateTime.Now.ToString("yyyy-MM-dd_HH.mm.ss.wav");
            wdt_waveIn = new NAudio.Wave.WasapiLoopbackCapture((NAudio.CoreAudioApi.MMDevice)gDev.SelectedItem);
            wdt_writer = new NAudio.Wave.WaveFileWriter(fn, wdt_waveIn.WaveFormat);
            wdt_waveIn.DataAvailable += wdt_OnDataAvailable;
            wdt_waveIn.StartRecording();

            gRate.Text = wdt_waveIn.WaveFormat.SampleRate + " Hz";
            gSize.Text = wdt_waveIn.WaveFormat.BitsPerSample + " bit";
            gCh.Text = wdt_waveIn.WaveFormat.Channels.ToString();
            gEnc.Text = wdt_waveIn.WaveFormat.Encoding.ToString();
            gStart.Text = "S T O P";
            trec.Start();
        }
        void wdt_OnDataAvailable(object sender, NAudio.Wave.WaveInEventArgs e)
        {
            wdt_writer.Write(e.Buffer, 0, e.BytesRecorded);
            double secondsRecorded = wdt_writer.Length / wdt_writer.WaveFormat.AverageBytesPerSecond;
            lock (locker)
            {
                if (ticker >= 0)
                {
                    ticker = (int)secondsRecorded;
                }
            }
        }
        void trec_Tick(object sender, EventArgs e)
        {
            if (ticker < 0)
            {
                trec.Stop();
                return;
            }
            int min = ticker / 60;
            int sec = ticker % 60;
            gTime.Text = string.Format("{0:00}:{1:00}", min, sec);
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            System.Diagnostics.Process.GetCurrentProcess().Kill();
        }
    }
}
